﻿<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="WebForm1.aspx.cs" Inherits="CancelRowAddingTest.WebForm1" %>

<%@ Register Assembly="Infragistics45.Web.v14.1, Version=14.1.20141.2011, Culture=neutral, PublicKeyToken=7dd5c3163f2cd0cb" Namespace="Infragistics.Web.UI.GridControls" TagPrefix="ig" %>

<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
  <title></title>
</head>
<body>
  <form id="form1" runat="server">
    <asp:ScriptManager ID="ScriptManager1" runat="server" />

    <script type="text/javascript">
      function onExitingEditMode(sender, e) {
        var cell = e.getCell();
        var text = e.get_displayText();

        var result = validateCell(cell, text);

        if (!result) {
          e.set_cancel(true);
        }
      }

      function keyDown(sender, e) {
        if (e.get_browserEvent().keyCode == 13) {
          var i = 0; //breakpoint here

          //var rowAdding = sender.get_behaviors().get_editingCore().get_behaviors().get_rowAdding();

          //var editingOn = rowAdding.getEditingOn(false, false, false);
          //if (editingOn == 4) {
          //  var cell = rowAdding.get_cellInEditMode();
          //  var row = rowAdding.get_row();

          //  for (var i = 0; i < row.get_cellCount() ; i++) {
          //    var cellToValidate = row.get_cell(i);
          //    if (cellToValidate != cell) {
          //      if (!validateCell(cellToValidate, cellToValidate.get_value())) {
          //        e.set_cancel(true);
          //      }
          //    }
          //  }
          //}
        }
      }

      // Checks if the cell is empty (invalid)
      function validateCell(cell, value) {
        var column = cell.get_column().get_key();
        var valid = true;

        switch (column) {
          case 'Prename':
            if (value == '') {
              valid = false;
            }
            break;
          case 'Surname':
            if (value == '') {
              valid = false;
            }
            break;
        }

        return valid;
      }
    </script>

    <ig:WebDataGrid ID="WebDataGrid1"
      runat="server"
      AutoGenerateColumns="false"
      Height="350px"
      Width="400px"
      ClientEvents-KeyDown="keyDown"
      DataKeyFields="ID">
      <Columns>
        <ig:BoundDataField Key="Prename" DataFieldName="Prename" />
        <ig:BoundDataField Key="Surname" DataFieldName="Surname" />
      </Columns>
      <Behaviors>
        <ig:Activation />
        <ig:EditingCore BatchUpdating="true">
          <Behaviors>
            <ig:RowAdding>
              <AddNewRowClientEvents ExitingEditMode="onExitingEditMode" />
              <EditModeActions MouseClick="Single" EnableOnActive="true" />
            </ig:RowAdding>
            <ig:CellEditing CellEditingClientEvents-ExitingEditMode="onExitingEditMode" />
          </Behaviors>
        </ig:EditingCore>
      </Behaviors>
    </ig:WebDataGrid>
    <asp:ListBox ID="listBox" runat="server" Width="100%" Height="500" />
  </form>
</body>
</html>
